Attribute VB_Name = "FonctionsDates"
'Option Compare Database

Option Explicit

'*****************************************************
'   Fonctions de calculs sur des jours fris        *
'   auteur : JeanMarc.Stoeffler@doublevez.com        *
'   version 6/11/1999 revu pour Airbus le 29/08/2006 *
' `...><((((>                                 *
' .`..`.><((((>                          *
' .`.. , . .`.. ><((((>                   *
' `..`..`..`...><((((>           *
'*****************************************************
' pour Access 2003 lire cette rponse : 'Acces2003
'*****************************************************
'Finalement, il n'y avait pas de bug :  en mettant
'plusieurs valeurs, j'en suis arriv  la conclusion
'qu'Access dmarre ses dates  partir du
'samedi 30 dcembre 1899  00:00.
'Et c'est ce qui s'est confirm  la lecture de cet article
'http://access.developpez.com/faq/?page=dates#durees

'Dans ta requte, pour avoir des " minutes_ouvrables " il
'suffisait de mettre le champ calcul
'TempsMinutes:HeuresOuvrables([ASSIGNTIME];[RESO_CLOSETIME])*24*60 et a marchait  l'arrondi prs.
'
'Pour avoir un vrai arrondi, il fallait ajouter cette fonction trouve chez
'http://www.developpez.net/forums/archive/index.php/t-193288.html  :
'TempsMinutes: ArrondiAccess(HeuresOuvrables([ASSIGNTIME];[RESO_CLOSETIME])*24*60;0)
'**********************************************************************************************************
'
Dim H_Db_Journe As Date 'service : heure de dbut
Dim H_Fin_Journe As Date 'service : heure de fin
Dim H_Db_Pause As Date   'pause   : heure de dbut
Dim H_Fin_Pause As Date   'pause   : heure de fin
Dim TempsPause As Date
Dim JourneTravail As Date
Dim Anne1 As Integer, AnneN As Integer, NbJoursFrisAn As Byte
Dim MotifVide As String
'------------------ indice1 = nb d'annes, indice2 = Nombre de jours fris)
Dim TableauJoursFris(40, 10) As Date 'prvu pour 41 annes et 11 jours fris par an

Public Sub InitialisationParamtres()
    'If Anne1 > 0 Then Exit Sub
    Anne1 = 1994        'modifiable mais attention  TableauJoursFris
    AnneN = 2030        'modifiable mais attention  TableauJoursFris
    NbJoursFrisAn = 11 'modifiable mais plus dlicat car "Sub InialisationJoursFris"  modifier
    '--------------------------------- paramtrage personnalisable en fonction des horaires
    H_Db_Journe = 7 / 24          '7h00   (modifiable)
    H_Fin_Journe = 19 / 24         '19h00  (modifiable)
    H_Db_Pause = 12 / 24           'pas de pause  (modifiable)
    H_Fin_Pause = 12 / 24           'pas de pause  (modifiable) si pas de pause mettre H_Db_Pause=H_Fin_Pause
    '---------------------------------
    TempsPause = H_Fin_Pause - H_Db_Pause
    JourneTravail = (H_Fin_Journe - H_Db_Journe) - TempsPause
    MotifVide = "-------"
End Sub

Public Function JoursOuvrables(JH_Dbut, JH_Fin)
    '-------------- calcul du nombre de journes de travail
    If JH_Dbut > 0 And JH_Fin > 0 Then
        Call InitialisationParamtres
        JoursOuvrables = HeuresOuvrables(CDate(JH_Dbut), CDate(JH_Fin)) / JourneTravail
    Else
        JoursOuvrables = MotifVide
    End If
End Function
Public Function JoursOuvrablesEntiers(JH_Dbut, JH_Fin)
    'JoursOuvrablesEntiers = "?": Exit Function   'debug
    '-------------- calcul du nombre de journes de travail
    If JH_Dbut > 0 And JH_Fin > 0 Then
        JoursOuvrablesEntiers = Int(JoursOuvrables(CDate(JH_Dbut), CDate(JH_Fin)))
    Else
        JoursOuvrablesEntiers = MotifVide
    End If
End Function

Public Function HeuresOuvrablesMaxUnJour(JH_Dbut, JH_Fin)
'-------------- calcul en nombre d'heures modulo 1 journe de travail
Dim Timing1 As Double, Timing2 As Double
    If JH_Dbut > 0 And JH_Fin > 0 Then
        Call InitialisationParamtres
        Timing1 = HeuresOuvrables(CDate(JH_Dbut), CDate(JH_Fin))
        Timing2 = Timing1 / JourneTravail
        HeuresOuvrablesMaxUnJour = (Timing2 - Int(Timing2)) * JourneTravail
    Else
        HeuresOuvrablesMaxUnJour = MotifVide
    End If
End Function
'source : http://www.developpez.net/forums/archive/index.php/t-193288.html  :
' utiliser sous Access
'voir commentaire du dbut de code
Function ArrondiAccess(nombre As Double, dec As Integer) As Double

Dim partieentiere As Long
Dim partiedec, y As Double
Dim x As Long

partieentiere = Int(nombre)
partiedec = nombre - partieentiere
x = partiedec * 10 ^ dec
y = x - Int(x)
If y >= 0.5 Then
x = x + 1
End If

Arrondi = partieentiere + x / (10 ^ dec)

End Function
Public Function HeuresOuvrables(Optional Dbut As Date, Optional Fin As Date)
'---------------------------------------------- dclarations

Dim JourHeureCalcul As Date  'heure pour le calcul
Dim JourCalcul As Date
Dim JourSemaine As Date
Dim HeureCalcul As Date
Dim Dure As Date
Dim JourDbut As Date
Dim JourFin As Date
Dim HeureDbut As Date
Dim HeureFin As Date
Dim Jour As Date
Dim temp As Integer

    Call InitialisationParamtres
    '------------------------------------------ saisie incomplte
    If Dbut = 0 Or Fin = 0 Then
        HeuresOuvrables = "?"
        Exit Function
    End If
    '------------------------------------------ erreur de saisie
    If Fin - Dbut < 0 Then
            HeuresOuvrables = "erreur date !"
            Exit Function
    End If
    '------------------------------------------ dates non prvue
    If EstFri(CDate(Dbut)) = -1 Or EstFri(CDate(Fin)) = -1 Then
            HeuresOuvrables = "Date extrme !"
            Exit Function
    End If
    '------------------------------------------ dbut programme
    JourDbut = Int(Dbut)
    HeureDbut = Dbut - JourDbut
    
    JourFin = Int(Fin)
    HeureFin = Fin - JourFin
    Dure = 0
    If JourDbut = JourFin Then                                 'cas 1 seul jour
        If EstOuvrable(JourDbut) = 1 Then
            Dure = CalculDure(HeureDbut, HeureFin)
        End If
      Else
        For Jour = JourDbut To JourFin ' balayage de tous les jours
            If EstOuvrable(Jour) = 1 Then                       'seulement si jour travaill
                If Jour = JourDbut And HeureDbut < H_Fin_Journe Then   'premier jour
                    Dure = CalculDure(HeureDbut, H_Fin_Journe)
                 Else
                    If Jour < JourFin Then                      ' jours intermdiaires
                        Dure = Dure + JourneTravail
                     Else                                       ' dernier jour
                        Dure = Dure + CalculDure(H_Db_Journe, HeureFin)
                    End If
                End If
            End If
        Next Jour
    End If
    '--------------------- conclusion
    'temp = (DatePart("h", Dure) * 60)
    'temp = temp + DatePart("n", Dure)
    'Dure = (DatePart("h", Dure) * 60) + DatePart("n", Dure)
    'temp = JourneTravail
    HeuresOuvrables = Dure
End Function

Public Function CalculDure(H_Dbut, H_Fin) As Date
    CalculDure = 0  ' par dfaut
'---------- 1 : anomalies
    If H_Dbut >= H_Fin Or H_Dbut > H_Fin_Journe Or H_Fin < H_Db_Journe Then Exit Function 'limination des extrmes
'---------- 2 : heure de dbut matinale
    If H_Dbut < H_Db_Journe Then H_Dbut = H_Db_Journe
'---------- 3 : heure de dbut au milieu de la pause
    If H_Dbut > H_Db_Pause And H_Dbut < H_Fin_Pause Then H_Dbut = H_Fin_Pause
'---------- 4 : heure de fin au milieu de la pause
    If H_Fin > H_Db_Pause And H_Fin < H_Fin_Pause Then H_Fin = H_Db_Pause
'---------- 5 : heure de fin tardive
    If H_Fin > H_Fin_Journe Then H_Fin = H_Fin_Journe
'---------- 6 : heure de dbut et heure de fin soit le matin soit l'aprs-midi
    If H_Dbut <= H_Db_Pause And H_Fin <= H_Db_Pause Or H_Dbut >= H_Fin_Pause And H_Fin >= H_Fin_Pause Then
        CalculDure = H_Fin - H_Dbut
    Else
'---------- 7 : heure de dbut le matin et heure de fin l'aprs-midi
        CalculDure = H_Fin - H_Dbut - TempsPause
    End If
End Function

Public Function EstOuvrable(JourDonn)
    ' prvoir les dates hors norme
    If JourDonn Mod 7 < 2 Or EstFri(CDate(JourDonn)) = 1 Then 'samedi et dimanche
       EstOuvrable = 0
    Else
       EstOuvrable = 1
    End If
End Function

Public Sub InialisationJoursFris()
Dim Indice As Integer, AnneI As Integer
Dim PaquesI As Date
    '--------------------------- on ne fera l'intialisation qu'une seule fois
    If TableauJoursFris(0, 0) <> 0 Then Exit Sub
    Call InitialisationParamtres
    For Indice = 0 To (AnneN - Anne1)
        AnneI = Anne1 + Indice
        PaquesI = Paques(AnneI)        'appel  la fonction Paques ci-dessus
        '------------------------------------------------------------*
        TableauJoursFris(Indice, 0) = DateSerial(AnneI, 1, 1)     ' nouvel an
        TableauJoursFris(Indice, 1) = PaquesI + 1                  ' lundi de Paques
        TableauJoursFris(Indice, 2) = DateSerial(AnneI, 5, 1)     ' 1er mai
        TableauJoursFris(Indice, 3) = DateSerial(AnneI, 5, 8)     ' 8 mai
        TableauJoursFris(Indice, 4) = PaquesI + 39                 ' Ascension
        TableauJoursFris(Indice, 5) = PaquesI + 50                 ' lundi dePentecote
        TableauJoursFris(Indice, 6) = DateSerial(AnneI, 7, 14)    ' fte Nat Fr.
        TableauJoursFris(Indice, 7) = DateSerial(AnneI, 8, 15)    ' assomption
        TableauJoursFris(Indice, 8) = DateSerial(AnneI, 11, 1)    ' Toussaint
        TableauJoursFris(Indice, 9) = DateSerial(AnneI, 11, 11)   ' 11 novembre
        TableauJoursFris(Indice, 10) = DateSerial(AnneI, 12, 25)  ' Nol
        '------------------------------------------------------------*
    Next Indice
End Sub
Public Function EstFri(UnJourDonn As Date)
Dim AnneI As Integer
Dim IndiceAnne As Integer
Dim IndiceJours As Byte
    Call InialisationJoursFris
    AnneI = Year(UnJourDonn)
    If AnneI < Anne1 Or AnneI > AnneN Then
        EstFri = -1
        Exit Function
    End If
    IndiceAnne = AnneI - Anne1
    For IndiceJours = 0 To NbJoursFrisAn - 1
    'NbJoursFrisAn est initialis  11 dans [InialisationJoursFris]
        If TableauJoursFris(IndiceAnne, IndiceJours) = Int(UnJourDonn) Then
            EstFri = 1
            Exit Function
        End If
    Next IndiceJours
    EstFri = 0
End Function
Public Sub TestJourFri()
Dim DateTest As Date
Dim Rponse As String
On Error GoTo TestJourFri_Err
    DateTest = InputBox("quelle date ? " & Chr(13) & "entre" & Anne1 & " et " & AnneN)
        Select Case EstFri(DateTest)
            Case -1
                Rponse = "est une date hors limites "

            Case 0
                Rponse = "est un jour non fri"
            Case 1
                Rponse = "est un jour FRI !"
        End Select
    MsgBox (DateTest & " : " & Chr$(13) & Rponse)

TestJourFri_Exit:
    Exit Sub

TestJourFri_Err:
    MsgBox "gloups !?!"
    Resume TestJourFri_Exit

End Sub
Function Paques(UneAnne)
'***************************************************************************
' Fonction Paques: date du jour de Paques en fonction de l'anne           *
' propose sur
'http://perso.wanadoo.fr/ana-chroniques  (auteur Jean MIART) *

' et trouve galement en 2003 ici
'http://mypage.bluewin.ch/w.stucki/CalculsDates.htm#Paques
'***************************************************************************
Dim var1 As Integer, var2 As Integer, var3 As Integer, var4 As Integer, var5 As Integer
Dim var6 As Integer, var7 As Integer, var8 As Integer, var9 As Integer, varA As Integer
Dim varB As Integer, varC As Integer, VarPaques As Integer
Dim JourDePaques As Integer, MoisDePaques As Integer
'------------------------------ dbut du calcul
    'Calcul du rang de l'anne dans le cycle lunaire qui a 19 ans
    var1 = UneAnne Mod 19     ' Reste de Anne par 19
    
    'Calcul du sicle
    var2 = UneAnne \ 100      ' Quotient de Anne par 100
    
    'Calcul du rang de l'anne dans le sicle
    var3 = UneAnne Mod 100    ' Reste de Anne par 100
    var4 = var2 \ 4
    var5 = var2 Mod 4
   
   'Synchronisation avec le cycle lunaire
    var6 = (var2 + 8) \ 25
    var7 = (1 + var2 - var6) \ 3
    var8 = (15 + (19 * var1) + var2 - var4 - var7) Mod 30
    var9 = var3 \ 4
    varA = var3 Mod 4
    varB = (32 + 2 * (var5 + var9) - var8 - varA) Mod 7
    varC = (var1 + (11 * var8) + (22 * varB)) \ 451
    VarPaques = (114 + var8 + varB - (7 * varC))

    ' ajout de jms
    JourDePaques = (VarPaques Mod 31) + 1
    MoisDePaques = Int(VarPaques / 31)
    Paques = DateSerial(UneAnne, MoisDePaques, JourDePaques)
' pour calculer :
' le lundi de Paques    = Paques + 1
' jeudi de l'ascension  = lundi de Paques + 38
' le lundi de pentecote (!) = lundi de Paques + 49
End Function



